import java.util.ArrayList;

/**
 * Cinta de simbolos de la maquina
 * Esta compuesta por una lista de celdas
 */
class Tape{

/**
 * Constructor de la cinta
 * Llena una porcion de la cinta con celdas en blanco
 */
  public Tape() {
  	cells = new ArrayList<Cell>();
    while (cells.size() < 19) {
      cells.add(new Cell("_"));
    }
  }

/**
 * Encuentra el valor de la cinta del lugar en que esta el cabezal
 * @param pos Posicion del cabezal
 * @return Valor de la celda
 */
  public String GetCellValue(int pos) {
  	return cells.get(pos).GetValue();
  }

/**
 * Escribe un simbolo en la cinta
 * @param symbol Simbolo a escribir
 * @param pos Posicion en la que se escribira
 */
  public void Write(String symbol, int pos) {
    cells.get(pos).ChangeValue(symbol);
  }

/**
 * Transforma la cinta en un string
 * @return Cinta como string
 */
  public String toString(int pos) {
    String s = "";
    for (int i = pos-9 ; i < pos +10 ; i++) {
      s+=cells.get(i);
      s+=" ";
    }
    return s;
  }

/**
 * Hace crecer la cinta agregando una celda en blanco por la derecha
 */
  public void GrowBack() {
    cells.add(new Cell("_"));
  }

/**
 * Hace crecer la cinta agregando una celda en blanco por la izquierda
 */
  public void GrowFront() {
    cells.add(0, new Cell("_"));
  }

/**
 * Entrega el largo de la cinta
 * @return Largo de la cinta
 */
  public int TapeSize() {
    return cells.size();
  }

/**
 * Llean la cinta con los simbolos ingresados por el usuario
 * @param entry Simbolos de entrada
 */
  public void Load(String entry) {
    cells.clear();
    for (int i = 0 ; i < 9 ; i++) {
      cells.add(new Cell("_"));
    }
    for (int i = 0 ; i < entry.length() ; i++) {
      cells.add(new Cell(entry.substring(i,i+1)));
    }
    while (cells.size() < 19) {
      cells.add(new Cell("_"));
    }
  }

  private ArrayList<Cell> cells;
  
}