import java.util.ArrayList;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

public class TuringMachine{
	public static void main(String[] args) {        
        TuringFrame frame = new TuringFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
	}
}

class TuringFrame extends JFrame {
    public TuringFrame() {
        setTitle("Turing Machine");
        setSize(250,250);

        Head head = new Head();

        TuringPanel panel = new TuringPanel(head);

        Container contentPane = getContentPane();
        contentPane.add(panel);

        MenuBar menu = new MenuBar(head);
        setJMenuBar(menu);
    }
}

class TuringPanel extends JPanel {
    public TuringPanel(Head h) {
        head = h;

        tapeEntry = new JTextField(15);

        startstopButton = new JButton("Start/Stop");
        startstopButton.addActionListener( new ActionListener (){
            public void actionPerformed(ActionEvent event) {
                head.final_state.setText("");
                if (head.ProgramLoaded()) {
                    head.StartStop();
                } else {
                    JOptionPane.showMessageDialog(null, "Cargue un programa");
                }
            };
        });

        loadTapeButton = new JButton("Load Tape");
        loadTapeButton.addActionListener( new ActionListener (){
            public void actionPerformed(ActionEvent event) {
                head.final_state.setText("");
                if (head.ProgramLoaded()) {
                    head.LoadTape(tapeEntry.getText());
                } else {
                    JOptionPane.showMessageDialog(null, "Cargue un programa");
                }
            };
        });

        add(startstopButton);
        add(head.tapeView);
        add(tapeEntry);
        add(loadTapeButton);
        add(head.final_state);
        add(head.stateView);
        //add(scrollPane);
    }

    private Head head;
    private JButton startstopButton;
    private JButton loadTapeButton;
    private JTextField tapeEntry;
}